/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.ParamAcumulaMasivo;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.ParamAcumulaMasivoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.zkoss.zk.ui.Component;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Spinner;

/**
 *
 * @author Rafius
 */
@Controller("editarParamAcumulaMasivoController")
@Scope("prototype")
public class EditarParamAcumulaMasivoController extends MyGenericForwardComposer {

    @Autowired
    private ParamAcumulaMasivoService paramAcumulaMasivoService;
    @Autowired
    private EmpresaService empresaService;
    private List<Empresa> lsEmpresa;
    private ParamAcumulaMasivo paramAcumulaMasivo;
    private MyListbox paramAcumulaMasivoList;
    private static Logger log = Logger.getLogger(EditarParamAcumulaMasivoController.class);
    private Combobox cmbEmpresa;
    private Datebox fecInicio;
    private Datebox fecFinal;
    private Spinner min;
    private Spinner max;
    private Button btnApagar;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsEmpresa =  UsuarioLogado.getUsuarioLogado().getEmpresa();

        super.doAfterCompose(comp);

        paramAcumulaMasivo = (ParamAcumulaMasivo) Executions.getCurrent().getArg().get("paramAcumulaMasivo");
        paramAcumulaMasivoList = (MyListbox) Executions.getCurrent().getArg().get("paramAcumulaMasivoList");

        if (paramAcumulaMasivo.getParamacumulamasivo() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        cmbEmpresa.focus();
    }

    public void onClick$btnSalvar(Event ev) {

        cmbEmpresa.getSelectedItem().getValue();
        fecInicio.getValue();
        fecFinal.getValue();
        min.getValue();
        max.getValue();

        if (fecInicio.getValue().after(fecFinal.getValue())) {
            try {
                Messagebox.show(
                        Labels.getLabel("editarParamCanjePuntoController.MSG.busquedaPeriodo"),
                        Labels.getLabel("editarParamCanjePuntoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
                log.error(ex);
            }
        } else {
            try {

                List<ParamAcumulaMasivo> lsParamAcumula = paramAcumulaMasivoService.buscar(paramAcumulaMasivo);

                boolean podeSalvar = false;
                if (lsParamAcumula.isEmpty()) {
                    podeSalvar = true;
                } else {
                    if (paramAcumulaMasivo.getParamacumulamasivo()!= null) {
                        for (ParamAcumulaMasivo p : lsParamAcumula) {
                            if (p.getParamacumulamasivo().equals(paramAcumulaMasivo.getParamacumulamasivo())) {
                                podeSalvar = true;
                            }
                        }
                    }
                }

                if (!podeSalvar) {
                    Messagebox.show(
                            Labels.getLabel("editarParamAcumulaMasivoController.MSG.conflitoVigencias"),
                            Labels.getLabel("editarParamAcumulaMasivoController.window.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                } else {

                    paramAcumulaMasivo.setActivo(true);
                    paramAcumulaMasivo.setFecmodif(Calendar.getInstance().getTime());
                    paramAcumulaMasivo.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

                    if (paramAcumulaMasivo.getParamacumulamasivo() == null) {
                        paramAcumulaMasivoService.suscribir(paramAcumulaMasivo);
                        paramAcumulaMasivoList.addItem(paramAcumulaMasivo);
                    } else {
                        paramAcumulaMasivoService.actualizacion(paramAcumulaMasivo);
                        paramAcumulaMasivoList.updateItem(paramAcumulaMasivo);
                    }

                    Messagebox.show(
                            Labels.getLabel("editarParamAcumulaMasivoController.MSG.suscribirOK"),
                            Labels.getLabel("editarParamAcumulaMasivoController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);

                    closeWindow();
                }
            } catch (Exception ex) {
                log.error(ex);
            }
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarParamAcumulaMasivoController.MSG.borrarPergunta"),
                    Labels.getLabel("editarParamAcumulaMasivoController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                paramAcumulaMasivoService.borrar(paramAcumulaMasivo);

                Messagebox.show(
                        Labels.getLabel("editarParamAcumulaMasivoController.MSG.borrarOK"),
                        Labels.getLabel("editarParamAcumulaMasivoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                paramAcumulaMasivoList.removeItem(paramAcumulaMasivo);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public Combobox getCmbEmpresa() {
        return cmbEmpresa;
    }

    public EmpresaService getEmpresaService() {
        return empresaService;
    }

    public void setEmpresaService(EmpresaService empresaService) {
        this.empresaService = empresaService;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }

    public ParamAcumulaMasivo getParamAcumulaMasivo() {
        return paramAcumulaMasivo;
    }

    public void setParamAcumulaMasivo(ParamAcumulaMasivo paramAcumulaMasivo) {
        this.paramAcumulaMasivo = paramAcumulaMasivo;
    }

    public MyListbox getParamAcumulaMasivoList() {
        return paramAcumulaMasivoList;
    }

    public void setParamAcumulaMasivoList(MyListbox paramAcumulaMasivoList) {
        this.paramAcumulaMasivoList = paramAcumulaMasivoList;
    }

    public ParamAcumulaMasivoService getParamAcumulaMasivoService() {
        return paramAcumulaMasivoService;
    }

    public void setParamAcumulaMasivoService(ParamAcumulaMasivoService paramAcumulaMasivoService) {
        this.paramAcumulaMasivoService = paramAcumulaMasivoService;
    }

    public Datebox getFecFinal() {
        return fecFinal;
    }

    public void setFecFinal(Datebox fecFinal) {
        this.fecFinal = fecFinal;
    }

    public Datebox getFecInicio() {
        return fecInicio;
    }

    public void setFecInicio(Datebox fecInicio) {
        this.fecInicio = fecInicio;
    }

    public Spinner getMax() {
        return max;
    }

    public void setMax(Spinner max) {
        this.max = max;
    }

    public Spinner getMin() {
        return min;
    }

    public void setMin(Spinner min) {
        this.min = min;
    }
}
